// Generated by CoffeeScript 1.7.1
module.exports = {
  "enum": function(definition, context) {
    if (this.test_type("array", definition)) {
      return (function(_this) {
        return function(data, runtime) {
          var value, values, _i, _len;
          for (_i = 0, _len = definition.length; _i < _len; _i++) {
            value = definition[_i];
            if (_this.equal(data, value)) {
              return;
            }
          }
          values = definition.join(', ');
          return runtime.error(context, data, {
            description: "Value must be one of " + values + "."
          });
        };
      })(this);
    } else {
      throw new Error("Value of 'enum' MUST be an Array");
    }
  },
  equal: function(got, want) {
    if (want instanceof Array) {
      return this.array_equal(got, want);
    } else if (this.is_object(want)) {
      return this.object_equal(got, want);
    } else {
      return got === want;
    }
  },
  array_equal: function(got, want) {
    var i, item, _i, _len;
    if (!(got instanceof Array)) {
      return false;
    }
    if (want.length === 0) {
      return true;
    }
    if (got.length !== want.length) {
      return false;
    }
    for (i = _i = 0, _len = want.length; _i < _len; i = ++_i) {
      item = want[i];
      if (!this.equal(got[i], item)) {
        return false;
      }
    }
    return true;
  },
  object_equal: function(got, want) {
    var key, value;
    if (!this.is_object(got)) {
      return false;
    }
    if (Object.keys(got).length !== Object.keys(want).length) {
      return false;
    }
    for (key in want) {
      value = want[key];
      if (!this.equal(got[key], value)) {
        return false;
      }
    }
    return true;
  }
};
