// Generated by CoffeeScript 1.7.1
module.exports = {
  pattern: function(pattern, context) {
    var regex;
    if (!this.test_type("string", pattern)) {
      throw new Error("Value of 'pattern' must be a string");
    }
    regex = new RegExp(pattern);
    return (function(_this) {
      return function(data, runtime) {
        if (_this.test_type("string", data)) {
          if (!regex.test(data)) {
            return runtime.error(context, data, {
              description: "String did not match regex pattern."
            });
          }
        }
      };
    })(this);
  },
  minLength: function(value, context) {
    if (!this.test_type("integer", value)) {
      throw new Error("Value of 'minLength' must be an integer");
    }
    return (function(_this) {
      return function(data, runtime) {
        if (_this.test_type("string", data)) {
          if (!(data.length >= value)) {
            return runtime.error(context, data, {
              description: "String must be longer than " + value + " bytes."
            });
          }
        }
      };
    })(this);
  },
  maxLength: function(value, context) {
    if (!this.test_type("integer", value)) {
      throw new Error("Value of 'maxLength' must be an integer");
    }
    return (function(_this) {
      return function(data, runtime) {
        if (_this.test_type("string", data)) {
          if (!(data.length <= value)) {
            return runtime.error(context, data, {
              description: "String must be smaller than " + value + " bytes."
            });
          }
        }
      };
    })(this);
  }
};
